(* ------------------------------------------------------ *)
(*                    SCANWERT.INC                        *)

CONST Scan_Ziffern1 : ARRAY[1..20] OF INTEGER = (
  (* 1     *) $0231, (* 2     *) $0332, (* 3     *) $0433,
  (* 4     *) $0534, (* 5     *) $0635, (* 6     *) $0736,
  (* 7     *) $0837, (* 8     *) $0938, (* 9     *) $0A39,
  (* 0     *) $0B30, (* Alt_1 *) $7800, (* Alt_2 *) $7900,
  (* Alt_3 *) $7A00, (* Alt_4 *) $7B00, (* Alt_5 *) $7C00,
  (* Alt_6 *) $7D00, (* Alt_7 *) $7E00, (* Alt_8 *) $7F00,
  (* Alt_9 *) $8000, (* Alt_0 *) $8100          );

VAR   Scan_Ziffern  : ARRAY[1..2,1..10] OF INTEGER
                         ABSOLUTE Scan_Ziffern1;

CONST Scan_Buchstaben1 : ARRAY[1..104] OF INTEGER = (
  (* a     *) $1E61, (* b     *) $3062, (* c     *) $2E63,
  (* d     *) $2064, (* e     *) $1265, (* f     *) $2166,
  (* g     *) $2267, (* h     *) $2368, (* i     *) $1769,
  (* j     *) $246A, (* k     *) $256B, (* l     *) $266C,
  (* m     *) $326D, (* n     *) $316E, (* o     *) $186F,
  (* p     *) $1970, (* q     *) $1071, (* r     *) $1372,
  (* s     *) $1F73, (* t     *) $1474, (* u     *) $1675,
  (* v     *) $2F76, (* w     *) $1177, (* x     *) $2D78,
  (* y     *) $1579, (* z     *) $2C7A, (* A     *) $1E41,
  (* B     *) $3042, (* C     *) $2E43, (* D     *) $2044,
  (* E     *) $1245, (* F     *) $2146, (* G     *) $2247,
  (* H     *) $2348, (* I     *) $1749, (* J     *) $244A,
  (* K     *) $254B, (* L     *) $264C, (* M     *) $324D,
  (* N     *) $314E, (* O     *) $184F, (* P     *) $1950,
  (* Q     *) $1051, (* R     *) $1352, (* S     *) $1F53,
  (* T     *) $1454, (* U     *) $1655, (* V     *) $2F56,
  (* W     *) $1157, (* X     *) $2D58, (* Y     *) $1559,
  (* Z     *) $2C5A, (* ^A    *) $1E01, (* ^B    *) $3002,
  (* ^C    *) $2E03, (* ^D    *) $2004, (* ^E    *) $1205,
  (* ^F    *) $1205, (* ^G    *) $2207, (* ^H    *) $2308,
  (* ^I    *) $1709, (* ^J    *) $240A, (* ^K    *) $250B,
  (* ^L    *) $260C, (* ^M    *) $320D, (* ^N    *) $310E,
  (* ^O    *) $180F, (* ^P    *) $1910, (* ^Q    *) $1011,
  (* ^R    *) $1312, (* ^S    *) $1F13, (* ^T    *) $1414,
  (* ^U    *) $1615, (* ^V    *) $2F16, (* ^W    *) $1117,
  (* ^X    *) $2D18, (* ^Y    *) $1519, (* ^Z    *) $2C1A,
  (* Alt_A *) $1E00, (* Alt_B *) $3000, (* Alt_C *) $2E00,
  (* Alt_D *) $2000, (* Alt_E *) $1200, (* Alt_F *) $2100,
  (* Alt_G *) $2200, (* Alt_H *) $2300, (* Alt_I *) $1700,
  (* Alt_J *) $2400, (* Alt_K *) $2500, (* Alt_L *) $2600,
  (* Alt_M *) $3200, (* Alt_N *) $3100, (* Alt_O *) $1800,
  (* Alt_P *) $1900, (* Alt_Q *) $1000, (* Alt_R *) $1300,
  (* Alt_S *) $1F00, (* Alt_T *) $1400, (* Alt_U *) $1600,
  (* Alt_V *) $2F00, (* Alt_W *) $1100, (* Alt_X *) $2D00,
  (* Alt_Y *) $1500, (* Alt_Z *) $2C00              );

VAR   Scan_Buchstaben  : ARRAY[1..4,'a'..'z'] OF INTEGER
                         ABSOLUTE Scan_Buchstaben1;

CONST Scan_FunkTasten1 : ARRAY[1..40] OF INTEGER = (
  (* F1        *) $3B00, (* F2        *) $3C00,
  (* F3        *) $3D00, (* F4        *) $3E00,
  (* F5        *) $3F00, (* F6        *) $4000,
  (* F7        *) $4100, (* F8        *) $4200,
  (* F9        *) $4300, (* F10       *) $4400,
  (* Alt_F1    *) $6800, (* Alt_F2    *) $6900,
  (* Alt_F3    *) $6A00, (* Alt_F4    *) $6B00,
  (* Alt_F5    *) $6C00, (* Alt_F6    *) $6D00,
  (* Alt_F7    *) $6E00, (* Alt_F8    *) $6F00,
  (* Alt_F9    *) $7000, (* Alt_F10   *) $7100,
  (* Ctrl_F1   *) $5E00, (* Ctrl_F2   *) $5F00,
  (* Ctrl_F3   *) $6000, (* Ctrl_F4   *) $6100,
  (* Ctrl_F5   *) $6200, (* Ctrl_F6   *) $6300,
  (* Ctrl_F7   *) $6400, (* Ctrl_F8   *) $6500,
  (* Ctrl_F9   *) $6600, (* Ctrl_F10  *) $6700,
  (* Shift_F1  *) $5400, (* Shift_F2  *) $5500,
  (* Shift_F3  *) $5600, (* Shift_F4  *) $5700,
  (* Shift_F5  *) $5800, (* Shift_F6  *) $5900,
  (* Shift_F7  *) $5A00, (* Shift_F8  *) $5B00,
  (* Shift_F9  *) $5C00, (* Shift_F10 *) $5D00     );

VAR   Scan_FunkTasten  : ARRAY[1..4,1..10] OF INTEGER
                         ABSOLUTE Scan_FunkTasten1;

CONST Scan_NumBlock : ARRAY[0..10] OF INTEGER = (
  (* Ins  *) $5200, (* End  *) $4F00, (* Pfu  *) $5000,
  (* Pdn  *) $5100, (* Pfl  *) $4B00, (* Fnf *) $0000,
  (* Pfr  *) $4D00, (* Home *) $4700, (* Pfo  *) $4800,
  (* Pup  *) $4900, (* Del  *) $5300            );

CONST Scan_Ctrl_NumBlock : ARRAY[1..9] OF INTEGER = (
  (* Ctrl_End  *) $7500, (* Zwei      *) $0000,
  (* Ctrl_Pdn  *) $7600, (* Ctrl_Pfl  *) $7300,
  (* Fnf      *) $0000, (* Ctrl_Pfr  *) $7400,
  (* Ctrl_Home *) $7700, (* Acht      *) $0000,
  (* Ctrl_Pup  *) $8400                             );

CONST Scan_Backspace : ARRAY[1..2] OF INTEGER = (
   (* BackSpace      *) $0E08,
   (* Ctrl_BackSpace *) $0E7F                   );

CONST Scan_Tab : ARRAY[1..2] OF INTEGER = (
   (* Tab       *) $0F09,
   (* Shift_Tab *) $0F00                  );

CONST Scan_ESC_RET : ARRAY[0..2] OF INTEGER = (
   (* ESC      *) $011B,
   (* Ret      *) $1C0D,
   (* Ctrl_Ret *) $1C0A                       );

(* ------------------------------------------------------ *)
(*                 Ende von SCANWERT.INC                  *)